#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/sysctl.h>
#include <machine/clock.h>
#include <machine/cputypes.h>

static int  
sysctl_hw_cpuspeed(SYSCTL_HANDLER_ARGS)
{
        int error;
        char mhz[30];   
        bzero(mhz, 30);
        if(cpu_class == CPUCLASS_586 || cpu_class == CPUCLASS_686) {
                sprintf(mhz, "%d.%02d-MHz ",
                        (tsc_freq + 4999) / 1000000,
                        ((tsc_freq + 4999) / 10000) % 100);
                error = sysctl_handle_string(oidp,
                        mhz, strlen(mhz), req);
        }
        else {
                error = EOPNOTSUPP;
        }
        return(error);
}
        
SYSCTL_PROC(_hw, OID_AUTO, cpuspeed, CTLTYPE_STRING|CTLFLAG_RD,
        0, 0, sysctl_hw_cpuspeed, "A", "Primary CPU speed");

